// This file is part of Basilisk-node.

// Copyright (C) 2020-2021  Intergalactic, Limited (GIB).
// SPDX-License-Identifier: Apache-2.0

// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

//! Autogenerated weights for pallet_democracy
//!
//! THIS FILE WAS AUTO-GENERATED USING THE SUBSTRATE BENCHMARK CLI VERSION 4.0.0-dev
//! DATE: 2022-11-02, STEPS: 5, REPEAT: 20, LOW RANGE: [], HIGH RANGE: []
//! EXECUTION: Some(Wasm), WASM-EXECUTION: Compiled, CHAIN: Some("dev"), DB CACHE: 1024

// Executed Command:
// target/release/basilisk
// benchmark
// pallet
// --chain=dev
// --steps=5
// --repeat=20
// --execution=wasm
// --wasm-execution=compiled
// --heap-pages=4096
// --template=.maintain/pallet-weight-template-no-back.hbs
// --pallet=pallet_democracy
// --output=democracy.rs
// --extrinsic=*
#![allow(unused_parens)]
#![allow(unused_imports)]
#![allow(clippy::unnecessary_cast)]

use frame_support::{
	traits::Get,
	weights::{constants::RocksDbWeight, Weight},
};
use sp_std::marker::PhantomData;

use pallet_democracy::weights::WeightInfo;

pub struct BasiliskWeight<T>(PhantomData<T>);

impl<T: frame_system::Config> WeightInfo for BasiliskWeight<T> {
	fn propose() -> Weight {
		Weight::from_ref_time(69_633_000 as u64)
			.saturating_add(T::DbWeight::get().reads(3 as u64))
			.saturating_add(T::DbWeight::get().writes(3 as u64))
	}
	fn second(s: u32) -> Weight {
		Weight::from_ref_time(48_847_000 as u64) // Standard Error: 3_000
			.saturating_add(Weight::from_ref_time(135_000 as u64).saturating_mul(s as u64))
			.saturating_add(T::DbWeight::get().reads(1 as u64))
			.saturating_add(T::DbWeight::get().writes(1 as u64))
	}
	fn vote_new(r: u32) -> Weight {
		Weight::from_ref_time(62_363_000 as u64) // Standard Error: 3_000
			.saturating_add(Weight::from_ref_time(202_000 as u64).saturating_mul(r as u64))
			.saturating_add(T::DbWeight::get().reads(3 as u64))
			.saturating_add(T::DbWeight::get().writes(3 as u64))
	}
	fn vote_existing(r: u32) -> Weight {
		Weight::from_ref_time(62_176_000 as u64) // Standard Error: 4_000
			.saturating_add(Weight::from_ref_time(204_000 as u64).saturating_mul(r as u64))
			.saturating_add(T::DbWeight::get().reads(3 as u64))
			.saturating_add(T::DbWeight::get().writes(3 as u64))
	}
	fn emergency_cancel() -> Weight {
		Weight::from_ref_time(32_562_000 as u64)
			.saturating_add(T::DbWeight::get().reads(2 as u64))
			.saturating_add(T::DbWeight::get().writes(2 as u64))
	}
	fn blacklist(p: u32) -> Weight {
		Weight::from_ref_time(62_035_000 as u64) // Standard Error: 56_000
			.saturating_add(Weight::from_ref_time(625_000 as u64).saturating_mul(p as u64))
			.saturating_add(T::DbWeight::get().reads(4 as u64))
			.saturating_add(T::DbWeight::get().writes(5 as u64))
	}
	fn external_propose(v: u32) -> Weight {
		Weight::from_ref_time(21_317_000 as u64) // Standard Error: 1_000
			.saturating_add(Weight::from_ref_time(29_000 as u64).saturating_mul(v as u64))
			.saturating_add(T::DbWeight::get().reads(2 as u64))
			.saturating_add(T::DbWeight::get().writes(1 as u64))
	}
	fn external_propose_majority() -> Weight {
		Weight::from_ref_time(8_930_000 as u64).saturating_add(T::DbWeight::get().writes(1 as u64))
	}
	fn external_propose_default() -> Weight {
		Weight::from_ref_time(8_679_000 as u64).saturating_add(T::DbWeight::get().writes(1 as u64))
	}
	fn fast_track() -> Weight {
		Weight::from_ref_time(31_951_000 as u64)
			.saturating_add(T::DbWeight::get().reads(2 as u64))
			.saturating_add(T::DbWeight::get().writes(3 as u64))
	}
	fn veto_external(v: u32) -> Weight {
		Weight::from_ref_time(33_419_000 as u64) // Standard Error: 1_000
			.saturating_add(Weight::from_ref_time(41_000 as u64).saturating_mul(v as u64))
			.saturating_add(T::DbWeight::get().reads(2 as u64))
			.saturating_add(T::DbWeight::get().writes(2 as u64))
	}
	fn cancel_proposal(p: u32) -> Weight {
		Weight::from_ref_time(69_673_000 as u64) // Standard Error: 8_000
			.saturating_add(Weight::from_ref_time(293_000 as u64).saturating_mul(p as u64))
			.saturating_add(T::DbWeight::get().reads(3 as u64))
			.saturating_add(T::DbWeight::get().writes(3 as u64))
	}
	fn cancel_referendum() -> Weight {
		Weight::from_ref_time(23_219_000 as u64).saturating_add(T::DbWeight::get().writes(1 as u64))
	}
	fn cancel_queued(r: u32) -> Weight {
		Weight::from_ref_time(36_915_000 as u64) // Standard Error: 6_000
			.saturating_add(Weight::from_ref_time(1_957_000 as u64).saturating_mul(r as u64))
			.saturating_add(T::DbWeight::get().reads(2 as u64))
			.saturating_add(T::DbWeight::get().writes(2 as u64))
	}
	fn on_initialize_base(r: u32) -> Weight {
		Weight::from_ref_time(12_788_000 as u64) // Standard Error: 7_000
			.saturating_add(Weight::from_ref_time(2_924_000 as u64).saturating_mul(r as u64))
			.saturating_add(T::DbWeight::get().reads(2 as u64))
			.saturating_add(T::DbWeight::get().reads((1 as u64).saturating_mul(r as u64)))
			.saturating_add(T::DbWeight::get().writes(1 as u64))
	}
	fn on_initialize_base_with_launch_period(r: u32) -> Weight {
		Weight::from_ref_time(17_514_000 as u64) // Standard Error: 7_000
			.saturating_add(Weight::from_ref_time(2_921_000 as u64).saturating_mul(r as u64))
			.saturating_add(T::DbWeight::get().reads(5 as u64))
			.saturating_add(T::DbWeight::get().reads((1 as u64).saturating_mul(r as u64)))
			.saturating_add(T::DbWeight::get().writes(1 as u64))
	}
	fn delegate(r: u32) -> Weight {
		Weight::from_ref_time(68_145_000 as u64) // Standard Error: 15_000
			.saturating_add(Weight::from_ref_time(4_348_000 as u64).saturating_mul(r as u64))
			.saturating_add(T::DbWeight::get().reads(4 as u64))
			.saturating_add(T::DbWeight::get().reads((1 as u64).saturating_mul(r as u64)))
			.saturating_add(T::DbWeight::get().writes(4 as u64))
			.saturating_add(T::DbWeight::get().writes((1 as u64).saturating_mul(r as u64)))
	}
	fn undelegate(r: u32) -> Weight {
		Weight::from_ref_time(40_807_000 as u64) // Standard Error: 8_000
			.saturating_add(Weight::from_ref_time(4_340_000 as u64).saturating_mul(r as u64))
			.saturating_add(T::DbWeight::get().reads(2 as u64))
			.saturating_add(T::DbWeight::get().reads((1 as u64).saturating_mul(r as u64)))
			.saturating_add(T::DbWeight::get().writes(2 as u64))
			.saturating_add(T::DbWeight::get().writes((1 as u64).saturating_mul(r as u64)))
	}
	fn clear_public_proposals() -> Weight {
		Weight::from_ref_time(10_668_000 as u64).saturating_add(T::DbWeight::get().writes(1 as u64))
	}
	fn note_preimage(b: u32) -> Weight {
		Weight::from_ref_time(36_858_000 as u64) // Standard Error: 0
			.saturating_add(Weight::from_ref_time(3_000 as u64).saturating_mul(b as u64))
			.saturating_add(T::DbWeight::get().reads(1 as u64))
			.saturating_add(T::DbWeight::get().writes(1 as u64))
	}
	fn note_imminent_preimage(b: u32) -> Weight {
		Weight::from_ref_time(34_379_000 as u64) // Standard Error: 0
			.saturating_add(Weight::from_ref_time(2_000 as u64).saturating_mul(b as u64))
			.saturating_add(T::DbWeight::get().reads(1 as u64))
			.saturating_add(T::DbWeight::get().writes(1 as u64))
	}
	fn reap_preimage(b: u32) -> Weight {
		Weight::from_ref_time(44_966_000 as u64) // Standard Error: 0
			.saturating_add(Weight::from_ref_time(2_000 as u64).saturating_mul(b as u64))
			.saturating_add(T::DbWeight::get().reads(1 as u64))
			.saturating_add(T::DbWeight::get().writes(1 as u64))
	}
	fn unlock_remove(r: u32) -> Weight {
		Weight::from_ref_time(46_275_000 as u64) // Standard Error: 2_000
			.saturating_add(Weight::from_ref_time(120_000 as u64).saturating_mul(r as u64))
			.saturating_add(T::DbWeight::get().reads(3 as u64))
			.saturating_add(T::DbWeight::get().writes(3 as u64))
	}
	fn unlock_set(r: u32) -> Weight {
		Weight::from_ref_time(45_410_000 as u64) // Standard Error: 5_000
			.saturating_add(Weight::from_ref_time(167_000 as u64).saturating_mul(r as u64))
			.saturating_add(T::DbWeight::get().reads(3 as u64))
			.saturating_add(T::DbWeight::get().writes(3 as u64))
	}
	fn remove_vote(r: u32) -> Weight {
		Weight::from_ref_time(26_668_000 as u64) // Standard Error: 7_000
			.saturating_add(Weight::from_ref_time(151_000 as u64).saturating_mul(r as u64))
			.saturating_add(T::DbWeight::get().reads(2 as u64))
			.saturating_add(T::DbWeight::get().writes(2 as u64))
	}
	fn remove_other_vote(r: u32) -> Weight {
		Weight::from_ref_time(26_386_000 as u64) // Standard Error: 7_000
			.saturating_add(Weight::from_ref_time(159_000 as u64).saturating_mul(r as u64))
			.saturating_add(T::DbWeight::get().reads(2 as u64))
			.saturating_add(T::DbWeight::get().writes(2 as u64))
	}
}
